
// Token.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, Jan 2018

/* The Lexer code returns a series of Token objects
   representing the lexical units in the language. 

   The tokens are input by the Parser to generate 
   a syntax tree.
*/

public class Token
{
  private Toks symbol;      // current token
  private String lexeme = null;   // token value as a string


  public Token(Toks sym)
  {  symbol = sym;  }


  public Token(Toks sym, String val)
  { symbol = sym;
    lexeme = val;
  }

  public Toks symbol()
  {  return symbol;  }


  public String lexeme()
  {  return lexeme; }


  public String toString()
  {
    if ((symbol == Toks.ID) ||
        (symbol == Toks.NUMBER))
      return "(" + symbol.getText() +": " + lexeme + ") ";
    else
      return symbol.getText();
  }  // end of toString()

}  // end of Token class
