
// Toks.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, Jan 2018

/* This enumeration defines the different types of
   tokens, which are used to distinguish between
   different Token objects.
*/

public enum Toks
{
  EOF("eof"), 

  // keywords
  IF("if"), 
  ELSE("else"), 
  WHILE("while"), 
  PRINT("print"), 
  READ("read"), 
  DIM("dim"), 
  NUMDPS("numdps"), 
  BEGIN("{"), 
  END("}"), 

  FUNC("func"), 
  CALL("call"), 
  RETURN("return"), 
  EXT("ext"), 

  // punctuation
  COMMA(","), 
  SEMICOLON(";"), 
  LBRACE("["), 
  RBRACE("]"), 

  // operators
  LPAREN("("), 
  RPAREN(")"), 
  AND("&&"), 
  OR("||"), 

  ASSIGN("="), 
  PLUS("+"), 
  MINUS("-"), 
  TIMES("*"), 
  DIV("/"), 

  EQ("=="), 
  LT("<"), 
  LE("<="), 
  GT(">"), 
  GE(">="), 
  NE("<>"), 

  // ids and data types
  ID("id"), 
  NUMBER("number"),
  STRING("string");


  private String text;


  Toks(String text) 
  {  this.text = text; }


  public String getText() 
  {  return this.text; }


  public static Toks fromString(String text) 
  {
    for (Toks b : Toks.values()) {
      if (b.text.equalsIgnoreCase(text))
        return b;
    }
    return EOF;
  }  // end of fromString()


}  // end of Toks class
