
// VarInfo.java
// Andrew Davison, ad@fivedots.coe.psu.ac.th, Feb 2018

/* Information about a variable. The CodeGen class
   generates a list of these for all the variables used
   by the intermediate code. 
*/


public class VarInfo
{
  private String id;
  private int size = 0;     // not an array
  private int address = -1;  // no address yet
  private boolean isDefined = false;


  public VarInfo(String id, int size)
  { this.id = id;
    this.size = size; 
  }

  public VarInfo(String id)
  {  this.id = id; }

  public String getID()
  {  return id;  }

  public int getSize()
  {  return size;  }

  public boolean isArray()
  {  return (size != 0);  }


  public void setDefined()
  {  isDefined = true;  }

  public boolean isDefined()
  {  return isDefined;  }

  public void setAddress(int n)
  {  address = n;  }

  public int getAddress()
  {  return address;  }


  public String toString()
  {  
    StringBuilder sb = new StringBuilder(id);
    if (isArray())
      sb.append("[" + size + "]");
    if (isDefined)
      sb.append(" DEF");
    if (address != -1)
      sb.append(" at " + address);

    return sb.toString();
  }  // end of toString()

}  // end of VarInfo class

